<div class="container-fluid">
  <div class="row">
    <!--Filters-->
    <div class="border-bottom-xl-rigth
                col-12 p-pt-5 pb-1
                col-xl-3">
      <div class="form-group d-flex justify-content-between align-items-center">
        <label>Date:</label>
        <app-calendar [(dateRange)]="calendarDateRange"></app-calendar>
      </div>
      <div class="form-group d-flex justify-content-between align-items-center">
        <label>Overhead:</label>
        <p-selectButton [options]="overheadOptions" [(ngModel)]="selectedOverhead" optionLabel="label"></p-selectButton>
      </div>
      <div class="form-group">
        <label>Projects:</label>
        <p-tree [value]="filterProjects" [(selection)]="selectedProjects" selectionMode="checkbox" [style]="{'width':'100%', 'padding':'0'}"></p-tree>
      </div>
      <div class="form-group">
        <p-button label="Apply" (click)="apply()"></p-button>
      </div>
    </div>
    <!--Data-->
    <div class="p-py-5
                col-12
                col-xl-9">
      <div class="form-group">
        <div class="row">
          <div class="col-sm-8 offset-sm-2">
            <p-table [scrollable]="true" [value]="userTotals" [autoLayout]="true" [scrollable]="true" styleClass="p-datatable-striped">
              <ng-template pTemplate="header">
                <tr>
                  <th>Account (Project)</th>
                  <th>Sum Internal</th>
                  <th>Sum External</th>
                </tr>
              </ng-template>
              <ng-template pTemplate="body" let-total>
                <tr>
                  <td>{{total.account.name}} ({{total.project.name}})</td>
                  <td>{{total.sumInternal}}</td>
                  <td>{{total.sumExternal}}</td>
                </tr>
              </ng-template>
              <ng-template pTemplate="footer" let-columns>
                <tr>
                  <td>
                    Total
                  </td>
                  <td>
                    {{totalInternal}}
                  </td>
                  <td>
                    {{totalExternal}}
                  </td>
                </tr>
              </ng-template>
            </p-table>
          </div>
        </div>
      </div>
      <p-table [scrollable]="true" [value]="timeReports" [style]="{width:'100%'}" [scrollable]="true" [autoLayout]="true" styleClass="p-datatable-striped">
        <ng-template pTemplate="header">
          <tr>
            <th>Date</th>
            <th>Account</th>
            <th>Project</th>
            <th style="white-space: nowrap">Int. / Ext.</th>
            <th>Description</th>
            <th>Overhead</th>
            <th style="width: 74px"></th>
          </tr>
        </ng-template>
        <ng-template pTemplate="body" let-report>
          <tr>
            <td>{{report.reportingDate | date:'shortDate':'+0000'}}</td>
            <td>{{report.account.name}}</td>
            <td>{{report.project.name}}</td>
            <td>{{report.internalHours}} / {{report.externalHours}}</td>
            <td style="white-space: pre-line">{{report.workDescription}}</td>
            <td>{{report.isOverhead ? 'Yes' : 'No'}}</td>
            <td>
              <div class="d-flex justify-content-between">
                <ng-template #editControls [ngTemplateOutlet]="editControls"
                  let-isTimeReportNotEditable="isTimeReportNotEditable"
                  let-isProjectClosed="isProjectClosed"
                  [ngTemplateOutletContext]="{ isTimeReportNotEditable: !report.isEditable, isProjectClosed: report.project.isClosed}"
                >
                  <div [pTooltip]="isProjectClosed ? 'Project is closed' : null" tooltipPosition="top" class="d-inline-block">
                    <button pButton class="ml-2 p-button-success" icon="fa fa-pencil"
                      [disabled]="isTimeReportNotEditable"
                      (click)="onEditTimeReport(report)"
                    ></button>
                  </div>
                  <div [pTooltip]="isProjectClosed ? 'Project is closed' : null" tooltipPosition="top" class="d-inline-block">
                    <button pButton class="ml-2  p-button-danger" icon="fa fa-times"
                      [disabled]="isTimeReportNotEditable"
                      (click)="onDeleteTimeReport(report)"
                    ></button>
                  </div>
                </ng-template>
              </div>
            </td>
          </tr>
        </ng-template>
        <ng-template pTemplate="emptymessage">
          <tr>
            <td colspan="7">
              No records found
            </td>
          </tr>
        </ng-template>
      </p-table>
    </div>

  </div>
</div>
<p-dialog #dialog
          [(visible)]="dialogVisible"
          [responsive]="true"
          [resizable]="false"
          [focusOnShow]="false"
          showEffect="fade"
          [modal]="true"
          [style]="{ 'width': '900px' }"
          [contentStyle]="{ 'max-height': 'calc(100vh - 200px)', 'overflow-y': 'auto' }">
    <app-time-report
      *ngIf="editTimeReport !== null"
      [projects]="projects"
      [(selectedProject)]="editTimeReport.project"
      [(date)]="reportingDate"
      [(internalHours)]="editTimeReport.internalHours"
      [(externalHours)]="editTimeReport.externalHours"
      [(isOverhead)]="editTimeReport.isOverhead"
      [(description)]="editTimeReport.workDescription"
      [(startTime)]="startTime"
      submitButtonLabel="Save"
      [allowMultipleDates]="false"
      (submitButtonClick)="onSave()"
      [appendInnerDialogToBody]="true"
    ></app-time-report>
</p-dialog>